package main

import (
	"fmt"
	"os"

	"github.com/xuri/excelize/v2"
)

const (
	FILE        = "TestFile.xlsm"
	FILE_EDITED = "EditedFile.xlsm"
	SHEET_NAME  = "table1"
	CELL_B3     = "B3"
	CELL_B4     = "B4"
	CELL_Z12    = "Z12"
)

func OpenExcel(name string) *excelize.File {
	file, err := excelize.OpenFile(name)
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}

	return file
}

func ExportDataFoo(file *excelize.File) {
	err := file.SetCellStr(SHEET_NAME, CELL_B3, "TestValueB3")
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}

	err = file.SetCellStr(SHEET_NAME, CELL_B4, "TestValueB4")
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}

	err = file.SaveAs(FILE_EDITED)
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}
}

func ExportDataFooWithoutSave(file *excelize.File) {
	err := file.SetCellStr(SHEET_NAME, CELL_B3, "TestValueB3")
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}

	err = file.SetCellStr(SHEET_NAME, CELL_B4, "TestValueB4")
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}
}

func ExportDataBar(file *excelize.File) {
	err := file.SetCellStr(SHEET_NAME, CELL_Z12, "TestValueZ12")
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}

	err = file.SaveAs(FILE_EDITED)
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}
}

func main() {
	file := OpenExcel(FILE)
	ExportDataFoo(file)
	ExportDataBar(file)
}
